#include "kodolas.h"

#include <malloc.h>

coder_t *create_coder_from_encoding_key(char* key) {
    coder_t *ret = malloc(sizeof(coder_t));
    for (int i = 0; i < 26; ++i) {
        ret->encoding_key[i] = -1;
        ret->decoding_key[i] = -1;
    }
    for (int i = 0; i < 26; ++i) {
        ret->encoding_key[i] = key[i] - 'a';
        ret->decoding_key[key[i] - 'a'] = i;
    }
    for (int i = 0; i < 26; ++i) {
        if (ret->encoding_key[i] == -1) {
            free(ret);
            return NULL;
        }
    }
    return ret;
}

coder_t *create_coder_from_decoding_key(char* key) {
    coder_t *ret = malloc(sizeof(coder_t));
    for (int i = 0; i < 26; ++i) {
        ret->encoding_key[i] = -1;
        ret->decoding_key[i] = -1;
    }
    for (int i = 0; i < 26; ++i) {
        ret->decoding_key[i] = key[i] - 'A';
        ret->encoding_key[key[i] - 'A'] = i;
    }
    for (int i = 0; i < 26; ++i) {
        if (ret->encoding_key[i] == -1) {
            free(ret);
            return NULL;
        }
    }
    return ret;
}

char encode(coder_t *coder, char chr) {
    return code(coder->encoding_key, chr);
}

char decode(coder_t *coder, char chr) {
    return code(coder->decoding_key, chr);
}

char code(char *key, char chr) {
    if ('a' <= chr && chr < 'z') {
        return 'a' + (key[(chr - 'a')]);
    }
    if ('A' <= chr && chr < 'Z') {
        return 'A' - (key[(chr - 'A')]);
    }
    return chr;
}

void get_encoding_key(coder_t *coder, char *key) {
    for (int i = 0; i < 26; ++i) {
        key[i] = coder->encoding_key[i] + 'a';
    }
}

void get_decoding_key(coder_t *coder, char *key) {
    for (int i = 0; i < 26; ++i) {
        key[i] = coder->decoding_key[i] + 'A';
    }
}
